# BitBasis

[![Build Status](https://github.com/QuantumBFS/BitBasis.jl/workflows/CI/badge.svg)](https://github.com/QuantumBFS/BitBasis.jl/actions)
[![Codecov](https://codecov.io/gh/QuantumBFS/BitBasis.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/QuantumBFS/BitBasis.jl)
[![Aqua QA](https://img.shields.io/badge/Aqua.jl-%F0%9F%8C%A2-aqua.svg)](https://github.com/JuliaTesting/Aqua.jl)


Types and operations for basis represented by bits in linear algebra.

## Installation

In Julia **v1.0+**, please type `]` in the REPL to use the package mode, then type this command:

```julia
pkg> add BitBasis
```

## Documentation

| stable  | dev  |
|:-------:|:-------:|
|[![doc-stable](https://img.shields.io/badge/docs-stable-blue.svg)](http://quantumbfs.github.io/BitBasis.jl/stable)|[![doc-latest](https://img.shields.io/badge/docs-latest-blue.svg)](http://quantumbfs.github.io/BitBasis.jl/latest)|


## License

Apache License 2.0

module BitBasis

export DitStr, BitStr, @bit_str, @lbit_str, @dit_str, @ldit_str, BitStr64, LongBitStr, DitStr64, LongDitStr, bit_literal
export onehot, buffer, indicator
export bitarray, basis, packbits, bfloat, bfloat_r, bint, bint_r, flip
export anyone, allone, bmask, baddrs, readbit, setbit, controller
export swapbits, ismatch, neg, breflect, btruncate
export LongLongUInt
export SubDitStr

include("utils.jl")
include("longlonguint.jl")
include("DitStr.jl")
include("BitStr.jl")
include("bit_operations.jl")
include("reorder.jl")
include("iterate_control.jl")

include("deprecations.jl")

end # module

using Test, BitBasis

@testset "longlonguint" begin
    x = LongLongUInt((3,))
    @test Int(x) === 3
    @test bsizeof(x) == 64
    @test BitBasis.nint(x) == 1
    @test bitstring(x) == "0000000000000000000000000000000000000000000000000000000000000011"

    x = LongLongUInt((3, 6))
    @test bitstring(x) == "00000000000000000000000000000000000000000000000000000000000000110000000000000000000000000000000000000000000000000000000000000110"
    @test zero(x) == LongLongUInt((0, 0))
    @test x << 1 == LongLongUInt((6, 12))
    @test x >> 1 == LongLongUInt((UInt(1), UInt(3) + UInt(1)<<63))
    @test count_ones(x) == 4
    @test ~x == LongLongUInt((~UInt(3), ~UInt(6)))
    @test promote(UInt(1), LongLongUInt((3, 4))) == (LongLongUInt((0, 1)), LongLongUInt((3, 4)))

    y = LongLongUInt((5, 7))
    @test one(y) == LongLongUInt((0, 1))
    @test x & y == LongLongUInt((1, 6))
    @test x | y == LongLongUInt((7, 7))
    @test x ⊻ y == LongLongUInt((6, 1))
    @test x + y == LongLongUInt((8, 13))
    z = LongLongUInt((5, 4))
    @test z - x == LongLongUInt((UInt64(1), typemax(UInt64)-1))

    # add with overflow
    z = LongLongUInt((UInt(17), typemax(UInt)-1))
    @test z + x == LongLongUInt((21, 4))
    @test (@allocated z + x) == 0

    # maximum number of elements
    BitBasis.max_num_elements(LongLongUInt{2}, 2) == 80
    BitBasis.max_num_elements(LongLongUInt{2}, 4) == 40
    BitBasis.max_num_elements(UInt, 2) == 64
    BitBasis.max_num_elements(Int, 2) == 63

    @test count_ones(bmask(LongLongUInt{50}, 1:3000)) == 3000
end

@testset "shift" begin
    x = LongLongUInt((3, ))
    @test x << 0 == LongLongUInt((3, ))
    @test x << 1 == LongLongUInt((3 << 1, ))
    @test x >> 1 == LongLongUInt((3 >> 1, ))

    x = LongLongUInt((3, 6))
    @test x << 0 == LongLongUInt((3, 6))
    @test x << 64 == LongLongUInt((6, 0))
    @test x << 65 == LongLongUInt((6<<1, 0))
    @test x >> 64 == LongLongUInt((0, 3))
    @test x >> 65 == LongLongUInt((0, 1))
    @test x << -65 == LongLongUInt((0, 1))
    @test x >> -65 == LongLongUInt((6<<1, 0))

    x = LongLongUInt((3, 6, 7))
    @test x >> 66 == LongLongUInt((UInt(0), UInt(0), UInt(3) << 62 + UInt(1)))
    @test x << 63 == LongLongUInt((UInt(1) << 63 + UInt(6) >> 1, UInt(7) >> 1, UInt(1)<<63))
end

@testset "longinttype" begin
    @test BitBasis.longinttype(1, 2) == LongLongUInt{1}
    @test BitBasis.longinttype(64, 2) == LongLongUInt{1}
    @test BitBasis.longinttype(65, 2) == LongLongUInt{2}
end

@testset "hash" begin
    @test hash(LongLongUInt((3, 6))) == hash(LongLongUInt((3, 6)))
    @test hash(LongLongUInt((3, 6))) != hash(LongLongUInt((6, 3)))
end

@testset "indicator" begin
    @test indicator(LongLongUInt{1}, 1) == LongLongUInt((1,))
    @test indicator(LongLongUInt{1}, 64) == LongLongUInt((UInt(1)<<63,))
    @test indicator(LongLongUInt{2}, 64) == LongLongUInt((zero(UInt), UInt(1)<<63))
    @test indicator(LongLongUInt{2}, 65) == LongLongUInt((1, 0))
end

@testset "takebit" begin
    x = LongLongUInt((3,))
    @test readbit(x, 1) == 1
    @test readbit(x, 2) == 1
    @test readbit(x, 3) == 0
    @test readbit(x, 4) == 0

    x = LongLongUInt((3, 6))
    @test readbit(x, 1) == 0
    @test readbit(x, 2) == 1
    @test readbit(x, 3) == 1
    @test readbit(x, 4) == 0

    @test readbit(x, 64) == 0
    @test readbit(x, 65) == 1
    @test readbit(x, 66) == 1
    @test readbit(x, 67) == 0
    @test readbit(BitStr{78}(x), 66) == 1
end

@testset "bmask" begin
    @test bmask(LongLongUInt{1}, 1:1) == LongLongUInt((UInt64(1),))
    @test bmask(LongLongUInt{2}, 1:65) == LongLongUInt((UInt64(1), typemax(UInt64)))
end

@testset "isless" begin
    x = LongLongUInt((3,))
    y = LongLongUInt((5,))
    @test x < y
    @test y > x

    x = LongLongUInt((3, 6))
    y = LongLongUInt((3, 7))
    @test x < y
    @test y > x

    x = LongLongUInt((3, 6))
    y = LongLongUInt((3, 6))
    @test !(x < y)
    @test !(y < x)
    @test x ≥ y
    @test y ≥ x

    xs = [LongLongUInt((3, 6)), LongLongUInt((3, 7)), LongLongUInt((2, 4))]
    sorted_xs = sort(xs)
    @test sorted_xs == [LongLongUInt((2, 4)), LongLongUInt((3, 6)), LongLongUInt((3, 7))]
end

using BitBasis
using Documenter
using DocThemeIndigo

indigo = DocThemeIndigo.install(BitBasis)

makedocs(
    modules = [BitBasis],
    repo = "https://github.com/QuantumBFS/BitBasis.jl/blob/{commit}{path}#{line}",
    format = Documenter.HTML(
        prettyurls = ("deploy" in ARGS),
        canonical = "https://quantumbfs.github.io/BitBasis.jl/dev/",
        assets = String[indigo, "assets/favicon.ico"],
    ),
    sitename = "BitBasis.jl",
    linkcheck = !("skiplinks" in ARGS),
    pages = ["Home" => "index.md", "Tutorial" => "tutorial.md", "Manual" => "man.md"],
    doctest=false,  # already tested in runtests.jl
)

deploydocs(repo = "github.com/QuantumBFS/BitBasis.jl.git")

export ReorderedBasis, reorder, invorder

using LinearAlgebra

"""
    ReorderedBasis{N, T}

Lazy reorderd basis.
"""
struct ReorderedBasis{N,T<:Integer}
    orders::NTuple{N,T}
    takers::NTuple{N,T}
    differ::NTuple{N,T}

    function ReorderedBasis{M,T}(
        orders::Tuple{T,Vararg{T,N}},
        takers::Tuple{T,Vararg{T,N}},
        differ::Tuple{T,Vararg{T,N}},
    ) where {M,T,N}
        N + 1 == M || error("length mismatch")
        new{M,T}(orders, takers, differ)
    end
end

"""
    ReorderedBasis(orders::NTuple{N, <:Integer})

Returns a lazy set of reordered basis.
"""
ReorderedBasis(orders::Tuple{T,Vararg{T,N}}) where {N,T<:Integer} =
    ReorderedBasis{N + 1,T}(orders, bmask.(orders), unsafe_sub(1:N, orders))

Base.length(::ReorderedBasis{N}) where {N} = 1 << N
Base.eltype(::ReorderedBasis{N,T}) where {N,T} = T
Base.getindex(it::ReorderedBasis, k::Int) = next_reordered_basis(k - 1, it.takers, it.differ)

function Base.iterate(it::ReorderedBasis{N}, state = 1) where {N}
    if state - 1 == 1 << N
        return nothing
    else
        return next_reordered_basis(state - 1, it.takers, it.differ), state + 1
    end
end

"""
    next_reordered_basis(basis, takers, differ)

Returns the next reordered basis accroding to current basis.
"""
function next_reordered_basis(basis::T, takers::NTuple{N,T}, differ::NTuple{N,T}) where {N,T}
    out = zero(T)
    # NOTE: do not add simd here, this will cause other loop become less efficient
    #       have some confidence with the compiler :-)
    for i in 1:N
        @inbounds out += (basis & takers[i]) << differ[i]
    end
    return out
end

"""
    unsafe_reorder(X::AbstractArray, orders)

Reorder `X` according to `orders`.

!!! warning

    `unsafe_reorder` won't check whether the length of `orders` and
    the size of first dimension of `X` match, use at your own risk.
"""
function unsafe_reorder end

function unsafe_reorder(v::AbstractVector, orders::NTuple{N,<:Integer}) where {N}
    nv = similar(v)
    for (k, b) in enumerate(ReorderedBasis(orders))
        @inbounds nv[k] = v[b+1]
    end
    return nv
end

function unsafe_reorder(A::AbstractMatrix, orders::NTuple{N,<:Integer}) where {N}
    od = Vector{Int}(undef, 1 << length(orders))
    for (i, b) in enumerate(ReorderedBasis(orders))
        @inbounds od[i] = 1 + b
    end

    od = invperm(od)
    return A[od, od]
end

function unsafe_reorder(A::Diagonal, orders::NTuple{N,<:Integer}) where {N}
    diag = similar(A.diag)
    for (i, b) in enumerate(ReorderedBasis(orders))
        @inbounds diag[b+1] = A.diag[i]
    end
    return Diagonal(diag)
end

function _reorder(v::AbstractArray, orders::NTuple{N,<:Integer}) where {N}
    length(orders) == log2dim1(v) ||
        throw(DimensionMismatch("size of array not match length of order"))
    return unsafe_reorder(v, orders)
end

"""
    reorder(X::AbstractArray, orders)

Reorder `X` according to `orders`.

!!! tip
    Although `orders` can be any iterable, `Tuple` is preferred inorder to
    gain as much performance as possible. But the conversion won't take much
    anyway.
"""
function reorder end

reorder(v::AbstractArray, itr) = _reorder(v, Tuple(itr))
reorder(v::AbstractArray, orders::Tuple) = _reorder(v, promote(orders...))
reorder(v::AbstractArray, orders::NTuple{N,<:Integer}) where {N} = _reorder(v, orders)

"""
    invorder(X::AbstractVecOrMat)

Inverse the order of given vector/matrix `X`.
"""
invorder(X::AbstractVecOrMat) = reorder(X, Tuple(log2dim1(X):-1:1))

using Test, BitBasis

@testset "bit literal" begin
    @test bit"1011" == 0b1011
    @test bit"100_111" == 0b100_111
    @test bit"10_100_11" == bit"1010011"
    @test bit"10_100_11" != bit"01010011"
    @test bit"1011" === bit_literal(Int64.((1, 1, 0, 1))...)
    @test BitBasis._parse_dit(Val(2), BigInt, "10101010101010101010101010101010010101010101"^10) isa BitStr
    @test BitBasis._parse_dit(Val(2), LongLongUInt, "10101010101010101010101010101010010101010101"^10) isa LongBitStr
    @test_throws ErrorException BitBasis._parse_dit(Val(2),
        Int64,
        "10101010101010101010101010101010010101010101"^10,
    )
    @test BitStr([0, 0, 1, 1]) == bit"1100"
end

@testset "operations" begin
    @test (bit"1010" + bit"0101") == bit"1111" == 15
    @test (bit"1111" - bit"0101") == bit"1010" == 10
    @test (bit"01010" * 2) == (2 * bit"01010") == bit"10100" == 20
    @test (bit"1010" ÷ 2) == bit"0101" == 5
    @test join(bit"101", bit"100", bit"111") == bit"101100111"
    @test join([bit"101" for k in 1:3]...) == bit"101101101"
    @test (bit"00101" << 2) == bit"10100"
    @test (bit"1101" >> 2) == bit"0011"
    @test bit"10011" == bit"10011"

    @test collect(bit"1101101") == Int64[1, 0, 1, 1, 0, 1, 1]
    @test length(bit"000":bit"111") == 8
    v = zeros(8)
    v[buffer(bit"101")+1] = 1
    @test onehot(bit"101") == v
    @test onehot(bit"101"; nbatch=2) == [v v]

    @test repeat(bit"101", 3) == bit"101101101"
end

@testset "conversions" begin
    for T in [Int8, Int16, Int32, Int64, Int128, BigInt]
        res = T(bit"10")
        @test typeof(res) == T
        @test res == 2
        res = convert(T, bit"10")
        @test res == 2
        @test typeof(res) == T

        @test convert(BitStr{2,LongLongUInt{1}}, convert(T, bit"10")) == lbit"10"
        @test convert(BitStr{2,Int64}, convert(T, bit"10")) === bit"10"
    end
end

@testset "indexing" begin
    A = rand(16)
    @test_throws ErrorException A[bit"1101"]
    @test bit"1101"[1] == 1
    @test bit"1101"[2] == 0
    @test bit"1101"[3] == 1
    @test bit"1101"[4] == 1

    mask = Bool[1, 0, 0, 0, 1, 1]
    @test bit"110101"[mask] == [1, 1, 1]
end

@testset "bitstr arithmetic" begin
    x = BitStr64{8}(99)
    y = BitStr64{8}(7)
    @test length(x) == 8
    for op in [+, -, *, ÷, |, ⊻, &, %, mod, mod1]
        z = op(x, y)
        @test z isa BitStr
        @test z == op(Int64(x), Int64(y))
        z = op(x, 7)
        @test z isa BitStr
        @test z == op(Int64(x), 7)
        z = op(7, y)
        @test z isa BitStr
        @test z == op(7, Int64(y))
    end
    @test -x === BitStr64{8}(-99)

    for op in [==, ≈]
        z = op(x, y)
        zz = op(Int64(x), Int64(y))
        @test typeof(z) == typeof(zz)
        @test z == zz
        z = op(x, 7)
        zz = op(Int64(x), 7)
        @test typeof(z) == typeof(zz)
        @test z == zz
        z = op(7, y)
        zz = op(7, Int64(y))
        @test typeof(z) == typeof(zz)
        @test z == zz
    end

    for op in [>, <, >=, <=]
        @test op(x, y) == op(Int64(x), Int64(y))
    end

    for op in [leading_ones, leading_zeros, count_ones, count_zeros, trailing_ones, trailing_zeros]
        op(x) == op(Int64(x))
    end
end

@testset "bitstr constructors" begin
    @test BitStr{8}(99) === BitStr{8,Int}(99)
    x = BitStr64{8}(99)
    y = BitStr64{8}(UInt64(7))
    @test zero(BitStr64{8}) == zero(BitStr64{8}(5)) == BitStr64{8}(0)
    @test reinterpret(BitStr{8,UInt64}, Int64(99)) === BitStr{8,UInt64}(99)
    @test reinterpret(Int64, BitStr64{8}(99)) === Int64(99)
    @test all(reinterpret(BitStr64{8}, [Int64(99)]) .=== [BitStr64{8}(99)])
    @test reinterpret(BitStr{8,Int64}, bit"1100") === bit"00001100"
    @test x == 99
    @test y == 7
    @test y != BitStr64{4}(7)
    @test bit"1001" == BitStr64{4}(9)
    @test lbit"1001" == bit"1001"
    @test typemax(x) == bit"11111111"
    @test typemax(typeof(x)) == bit"11111111"
    @test typemin(x) == bit"00000000"
    @test typemin(typeof(x)) == bit"00000000"
    @test typemin(BitStr64{4}) == bit"0000"
    @test typemax(BitStr64{4}) == bit"1111"
    @test typemin(x) == bit"00000000"
    @test typemin(typeof(x)) == bit"00000000"
    @test_throws ErrorException x + BitStr64{10}(x)
    @test BitStr64{10}(x) != x
    @test !(BitStr64{10}(x) ≈ x)
end

@testset "bitstr binaryop" begin
    x = bit"001110"
    @test baddrs(x) == [2, 3, 4]
    @test breflect(x) === bit"011100"
    @test breflect(x, [bit"000011", bit"101000"]) === bit"100101"
    msk = bmask(BitStr64{6}, 1, 2, 3)
    @test flip(x, msk) === bit"001001"
    @test setbit(x, msk) === bit"001111"
    @test readbit(x, 3) === bit"000001"
    @test readbit(x, 3, 4) === bit"000011"
    @test anyone(x, msk) === true
    @test allone(x, msk) === false
    @test ismatch(x, msk, bit"000110") === true
    @test ismatch(x, msk, bit"100110") === false
    @test length(basis(x)) == 2^6
    @test length(basis(typeof(x))) == 2^6
    @test basis(x)[1] === bit"000000"

    @test neg(x) === bit"110001"
    @test swapbits(x, bit"101000") === bit"100110"

    @test basis(bit"000") == bit"000":bit"111"
    @test basis(BitStr{3,Int64}) == bit"000":bit"111"
    @test eltype(x) == Int64 == eltype(x[1])
end

@testset "bitstr indexing" begin
    x = bit"001110"
    @test x[1] === Int64(0)
    @test x[2] === Int64(1)
    @test_throws BoundsError x[10]
    @test x[[true, false, true, true, true, false]] == [0, 1, 1, 0]
    @test x[1:2] == [0, 1]
    @test x[[1, 4]] == [0, 1]
    @test lastindex(x) == 6
    @test Base.IteratorSize(x) == Base.HasLength()
end

@testset "bitstr readout" begin
    x = bit"001110"
    @test bint(x) === Int64(14)
    @test bint_r(x) === Int64(28)
    @test bfloat(x) === 28 / 2^6
    @test bfloat_r(x) === 14 / 2^6
    @test btruncate(x, 3) === bit"000110"
end

@testset "LongDitStr" begin
    x = LongBitStr(rand(0:1, 64 * 3))
    @test bsizeof(x.buf) == 64 * 3
    x = LongBitStr(rand(0:1, 64 * 3+1))
    @test bsizeof(x.buf) == 64 * 4
end

export bsizeof, bdistance, bit_length, onehot, log2i, hypercubic, log2dim1, indices_with
# NOTE: all binary specified operations begin with b

"""
    bsizeof(::Type)

Returns the size of given type in number of binary digits.
"""
bsizeof(::Type{T}) where {T} = sizeof(T) << 3
bsizeof(::T) where {T} = bsizeof(T)

"""
    bdistance(i::Integer, j::Integer) -> Int

Return number of different bits.
"""
bdistance(i::Ti, j::Ti) where {Ti<:Integer} = count_ones(i ⊻ j)

function _onehot(::Type{T}, n::Integer, loc::Integer; nbatch::Union{Nothing,Int}=nothing) where {T}
    if nbatch === nothing
        v = zeros(T, n)
        v[loc] = one(T)
        return v
    else
        v = zeros(T, n, nbatch)
        v[loc, :] .= Ref(one(T))
        return v
    end
end

"""
    unsafe_sub(a::UnitRange, b::NTuple{N}) -> NTuple{N}

Returns result in type `Tuple` of `a .- b`. This will not check the length of `a` and `b`, use
at your own risk.
"""
@generated function unsafe_sub(a::UnitRange{T}, b::NTuple{N,T}) where {N,T}
    ex = Expr(:tuple)
    for k in 1:N
        push!(ex.args, :(a.start + $(k - 1) - b[$k]))
    end
    return ex
end

"""
    unsafe_sub(a::UnitRange{T}, b::Vector{T}) where T

Returns `a .- b`, fallback version when b is a `Vector`.
"""
unsafe_sub(a::UnitRange{T}, b::Vector{T}) where {T} = a .- b

"""
    bit_length(x::Integer) -> Int

Return the number of bits required to represent input integer x.
"""
bit_length(x::Integer) = sizeof(x) * 8 - leading_zeros(x)

"""
    log2i(x::Integer) -> Integer

Return log2(x), this integer version of `log2` is fast but only valid for number equal to 2^n.
"""
function log2i end

for N in [8, 16, 32, 64, 128]
    T = Symbol(:Int, N)
    UT = Symbol(:UInt, N)
    @eval begin
        log2i(x::$T) =
            !signbit(x) ? ($(N - 1) - leading_zeros(x)) :
            throw(ErrorException("nonnegative expected ($x)"))
        log2i(x::$UT) = $(N - 1) - leading_zeros(x)
    end
end

"""
    log2dim1(X)

Returns the `log2` of the first dimension's size.
"""
log2dim1(X) = log2i(size(X, 1))

"""
    hypercubic(A::Array) -> Array

get the hypercubic representation for an array.
"""
hypercubic(A::Array) = reshape(A, fill(2, size(A) |> prod |> log2i)...)

"""
    indices_with(n::Int, locs::Vector{Int}, vals::Vector{Int}) -> Vector{Int}

Return indices with specific positions `locs` with value `vals` in a hilbert space of `n` qubits.
"""
function indices_with(n::Int, locs::Vector{Int}, vals::Vector{Int})
    mask = bmask(locs)
    onemask = bmask(locs[vals.!=0])
    return filter(x -> ismatch(x, mask, onemask), 0:1<<n-1)
end

@deprecate testany(index::T, mask::T) where {T<:Integer} anyone(index, mask)
@deprecate testall(index::T, mask::T) where {T<:Integer} allone(index, mask)
@deprecate testval(index::T, mask::T, onemask::T) where {T<:Integer} ismatch(index, mask, onemask)
@deprecate takebit(index::T, ibit::Int) where {T<:Integer} readbit(index, ibit)
@deprecate takebit(index::T, bits::Int...) where {T<:Integer} readbit(index, bits...)
@deprecate breflect(nbits::Int, b::Integer) breflect(b; nbits = nbits)
@deprecate breflect(nbits::Int, b::T, masks::Vector{T}) where {T} breflect(b, masks; nbits = nbits)
@deprecate bit(b; len) BitStr{len}(b)

@deprecate to_location(x::Integer) x + 1
@deprecate to_location(x::BitStr) buffer(x) + 1
@deprecate bcat join
@deprecate bit_literal(x::Integer, xs::Integer...) bit_literal((x, xs...))
@deprecate bit_literal(xs::Tuple{T,Vararg{T,N}}) where {T<:Integer,N} DitStr{2}(xs)

using BitBasis, Test

@testset "ditstr" begin
    x = dit"112100;3"
    @test x isa DitStr
    @test x |> length == 6
    println(x)
    @test buffer(x) === Int64(3^5 + 3^4 + 2 * 3^3 + 3^2)
    @test_throws ErrorException randn(100)[x]
    @test BitBasis.readat(x, 2) == Int64(0)
    @test x[2] == Int64(0)
    @test x[3] == Int64(1)
    @test x[4] == Int64(2)
    @test [x...] == Int64[0, 0, 1, 2, 1, 1]
    @test [DitStr{3}(Int64[0, 0, 1, 2, 1, 1])...] == Int64[0, 0, 1, 2, 1, 1]
    @test_throws ErrorException BitBasis.parse_dit(Int64, "112103;3")
    @test_throws ErrorException BitBasis.parse_dit(Int64, "112101;")

    @test join(dit"001;3", dit"002;3") == dit"001002;3"
    print(ldit"12341111111111111111111111111111111111111111111111111111111;5")
    @test_throws ErrorException Base.checkindex(Bool, 1:3, dit"22;3")
    @test BitBasis.readat(dit"001;3") == 0
    @test BitBasis.readat(dit"001;3", 1, 2, 3) == 1
    @test_throws ErrorException BitBasis.parse_dit(Int64, "12341111111111111111111111111111111111111111111111111111111;5")

    @test hash(x) isa UInt64
end

@testset "SubDitStr" begin
    x = dit"112100;3"
    sx = SubDitStr(x, 2, 4) # bit"210"
    @test_throws BoundsError SubDitStr(x, 2, 7)
    @test checkbounds(sx, 1) == nothing
    @test getindex(sx, 1) == 0
    @test getindex(sx, 2) == 1
    @test getindex(sx, 3) == 2
    @test_throws BoundsError getindex(sx, 4)
    @test_throws BoundsError getindex(sx, 0)
    @test length(sx) == 3
    @test sx == dit"210;3"
    @test dit"210;3" == sx
    @test DitStr(sx) == dit"210;3"
    @test SubDitStr(dit"210;3",1,length(dit"210;3")) == sx
    @test (@views x[4:end]) == dit"112;3"
    @test (@views x[begin:3]) == dit"100;3"   
end

using BitBasis, Random, SparseArrays, LinearAlgebra

DA = Diagonal(randn(2))
DB = Diagonal(randn(2))
DC = Diagonal(randn(2))
@test reorder(DC ⊗ DB ⊗ DA, [3, 1, 2]) ≈ DB ⊗ DA ⊗ DC
@test invorder(DC ⊗ DB ⊗ DA) ≈ DA ⊗ DB ⊗ DC

DA = sprand(2, 2, 0.5)
DB = sprand(2, 2, 0.5)
DC = sprand(2, 2, 0.5)
@test reorder(DC ⊗ DB ⊗ DA, [3, 1, 2]) ≈ DB ⊗ DA ⊗ DC
@test invorder(DC ⊗ DB ⊗ DA) ≈ DA ⊗ DB ⊗ DC

using Test, BitBasis

function swaprows!(v::AbstractVector, i::Int, j::Int)
    temp = v[i]
    v[i] = v[j]
    v[j] = temp
    v
end

function eye(b::Int)
    res = zeros(b, b)
    for i in 1:b
        res[i, i] = 1
    end
    res
end

mulrow!(v::AbstractVector, i::Int, f) = (v[i] *= f; v)

@testset "test group_shift!" begin
    @test group_shift!(5, [1, 2, 5]) == ([3, 28], [4, 8])
    @test group_shift!(5, [2, 3]) == ([1, 30], [1, 4])
    @test group_shift!(5, [1, 3, 5]) == ([1, 2, 28], [2, 4, 8])
    @test group_shift!(3, [1, 2, 3]) == ([7], [8])
    @test group_shift!(3, Int[]) == (Int[7], Int[1])
    @test [itercontrol(3, [1, 2, 3], [0,1,0])...] == [2]
    @test [itercontrol(3, Int[], Int[])...] == [0,1,2,3,4,5,6,7]
end

@testset "test IterControl" begin
    v = randn(ComplexF64, 1 << 4)
    it = itercontrol(4, [3], [1])
    vec = Int[]
    it2 = itercontrol(4, [3, 4], [0, 0])
    for i in it2
        push!(vec, i)
    end
    @test vec == [0, 1, 2, 3]
    @test it2[end] == 3

    vec = Int[]
    it4 = itercontrol(4, [4, 2, 1], [1, 1, 1])
    for i in it4
        push!(vec, i)
    end
    @test vec == [11, 15]

    # test controlled operations
    @testset "test controlled operations" begin
        P0 = ComplexF64[1 0; 0 0]
        P1 = ComplexF64[0 0; 0 1]
        Z = ComplexF64[1 0; 0 -1]

        rrr = copy(v)
        controldo(x -> mulrow!(rrr, x + 1, -1.0), it4)
        M =
            kron(P1, eye(2), P1, Z) +
            kron(P0, eye(2), P0, eye(2)) +
            kron(P1, eye(2), P0, eye(2)) +
            kron(P0, eye(2), P1, eye(2))
        @test rrr ≈ M * v

        it = itercontrol(8, [3], [1])
        V = randn(ComplexF64, 1 << 8)
        res = kron(eye(1 << 5), ComplexF64[0 1; 1 0], eye(1 << 2)) * V
        rrr = copy(V)
        controldo(x -> swaprows!(rrr, x + 1, x - 3), it)
        @test rrr ≈ res

        rrr = copy(V)
        controldo(x -> mulrow!(rrr, x + 1, -1), itercontrol(8, [3, 7, 6], [1, 1, 1]))

        M =
            kron(eye(2), P1, Z, eye(4), P1, eye(4)) +
            kron(eye(2), P0, eye(8), P0, eye(4)) +
            kron(eye(2), P1, eye(8), P0, eye(4)) +
            kron(eye(2), P0, eye(8), P1, eye(4))

        @test rrr ≈ M * V
        ic = itercontrol(4, [2, 3], [0, 0])
        @test [ic...] == [ic[k] for k in 1:4]
    end
end

@testset "regression test" begin
    @test_throws AssertionError itercontrol(8, [8, 8], [1, 1])
    @test_throws AssertionError itercontrol(8, [8], [-1])
end

using BitBasis
using Documenter
using Test
using Aqua
Aqua.test_all(BitBasis)

const ⊗ = kron

@testset "test dit literal" begin
    include("DitStr.jl")
end

@testset "test bit literal" begin
    include("BitStr.jl")
end

@testset "test operations" begin
    include("bit_operations.jl")
end

@testset "test reorder" begin
    include("reorder.jl")
end

@testset "test utils" begin
    include("utils.jl")
end

@testset "test iterate control" begin
    include("iterate_control.jl")
end

@testset "longlonguint" begin
    include("longlonguint.jl")
end

DocMeta.setdocmeta!(BitBasis, :DocTestSetup, :(using BitBasis); recursive=true)
Documenter.doctest(BitBasis; manual=false)

const UIntStorage = Union{UInt8, UInt16, UInt32, UInt64, UInt128, LongLongUInt}
const IntStorage = Union{Int8, Int16, Int32,Int64,Int128,BigInt,UIntStorage}

########## DitStr #########
"""
    DitStr{D,N,T<:Integer} <: Integer

The struct for dit string with fixed length `N` and storage type `T`,
where `dit` is a extension of `dit` from binary system to a d-ary system.

    DitStr{D,N,T}(integer)
    DitStr{D,N}(integer)
    DitStr{D}(vector)

Returns a `DitStr`.
When the input is an integer, the dits are read from right to left.
When the input is a vector, the dits are read from left to right.

### Examples

```jldoctest
julia> DitStr{3}([1,2,1,1,0])
01121 ₍₃₎

julia> DitStr{3, 5}(71)
02122 ₍₃₎
```
"""
struct DitStr{D,N,T<:Integer} <: Integer
    buf::T
    DitStr{D,N,T}(buf::IntStorage) where {D,N,T} = new{D,N,T}(buf)
    DitStr{D,N}(buf::IntStorage) where {D,N} = new{D,N,typeof(buf)}(buf)
end

# vector inputs
function DitStr{D,T}(vector::Union{AbstractVector,Tuple}) where {D,T}
    val = zero(T)
    D_power_k = one(T)
    for k in 1:length(vector)
        0 <= vector[k] <= D - 1 || error("expect 0-$(D-1), got $(vector[k])")
        val = accum(Val{D}(), val, vector[k], D_power_k)
        D_power_k = _lshift(Val{D}(), D_power_k, 1)
    end
    return DitStr{D,length(vector),T}(val)
end
# val += x * y
accum(::Val{D}, val, x, y) where {D} = val + x * y
accum(::Val{2}, val, x, y) = iszero(x) ? val : val ⊻ y
DitStr{D}(vector::Tuple{T,Vararg{T,N}}) where {N,T,D} = DitStr{D,T}(vector)
DitStr{D}(vector::AbstractVector{T}) where {D,T} = DitStr{D,T}(vector)
DitStr{D,N,T}(val::DitStr) where {D,N,T<:Integer} = convert(DitStr{D,N,T}, val)
DitStr{D,N,T}(val::DitStr{D,N,T}) where {D,N,T<:Integer} = val

const DitStr64{D,N} = DitStr{D,N,Int64}
const LongDitStr{D,N} = DitStr{D,N,LongLongUInt{C}} where {C}
LongDitStr{D}(vector::AbstractVector{T}) where {D,T} = DitStr{D,longinttype(length(vector), D)}(vector)

Base.show(io::IO, ditstr::DitStr{D,N,<:Integer}) where {D,N} =
    print(io, string(buffer(ditstr), base=D, pad=N), " ₍$('₀'+D)₎")
Base.show(io::IO, ditstr::DitStr{D,N,<:LongLongUInt}) where {D,N} =
    print(io, join(map(string, [ditstr[end:-1:1]...])), " ₍$('₀'+D)₎")

Base.zero(::Type{DitStr{D,N,T}}) where {D,N,T} = DitStr{D,N,T}(zero(T))
Base.zero(::DitStr{D,N,T}) where {D,N,T} = DitStr{D,N,T}(zero(T))

buffer(b::DitStr) = b.buf
Base.hash(d::DitStr) = hash(buffer(d))
Base.reinterpret(::Type{DitStr{D,N,T}}, x::Integer) where {D,N,T} = DitStr{D,N,T}(reinterpret(T, x))
Base.reinterpret(::Type{T}, x::DitStr) where {T} = reinterpret(T, buffer(x))
Base.reinterpret(::Type{DitStr{D,N,T}}, x::DitStr) where {D,N,T} = DitStr{D,N,T}(x)

Base.convert(::Type{T}, b::DitStr) where {T<:Integer} = convert(T, buffer(b))
Base.convert(::Type{T}, b::Integer) where {T<:DitStr} = T(b)
Base.convert(::Type{DitStr{D,N,T}}, b::DitStr{D,N,T}) where {D,N,T<:Integer} = b
Base.convert(::Type{T1}, b::DitStr{D,N2,T2}) where {D,T1<:DitStr,N2,T2<:Integer} = convert(T1, buffer(b))
for IT in [
    :BigInt,
    :Int128,
    :UInt128,
    :Int64,
    :UInt64,
    :Int32,
    :UInt32,
    :Int16,
    :UInt16,
    :Int8,
    :UInt8,
    :Bool,
]
    @eval Base.$IT(b::DitStr) = $IT(buffer(b))
end
for op in [:+, :-, :*, :÷, :|, :⊻, :&, :%, :mod, :mod1]
    @eval Base.$op(a::T, b::Integer) where {T<:DitStr} = T($op(buffer(a), b))
    @eval Base.$op(a::Integer, b::T) where {T<:DitStr} = T($op(a, buffer(b)))
    @eval Base.$op(a::DitStr{D,N,T}, b::DitStr{D,N,T}) where {D,N,T<:Integer} =
        DitStr{D,N,T}($op(buffer(a), buffer(b)))
    @eval Base.$op(a::DitStr, b::DitStr) = error("type mismatch: $(typeof(a)), $(typeof(b))")
end
Base.:-(x::DitStr{D,N,T}) where {D,N,T} = DitStr{D,N,T}(-buffer(x))

for op in [:<, :>, :(<=), :(>=)]
    @eval Base.$op(a::T, b::T) where {T<:DitStr} = Base.$op(buffer(a), buffer(b))
end

for Type in [Integer, BigInt, BigFloat]
    @eval Base.:(==)(a::T, b::$Type) where {T<:DitStr} = Base.:(==)(buffer(a), b)
    @eval Base.:(==)(a::$Type, b::T) where {T<:DitStr} = Base.:(==)(a, buffer(b))
end

Base.:(==)(a::DitStr{D,N}, b::DitStr{D,N}) where {D,N} = Base.:(==)(buffer(a), buffer(b))

# Note: the transitivity of == is not satisfied here.
Base.:(==)(lhs::DitStr, rhs::DitStr) = false
Base.isapprox(a::DitStr, b::Integer; kwargs...) = Base.isapprox(buffer(a), b; kwargs...)
Base.isapprox(a::Integer, b::DitStr; kwargs...) = Base.isapprox(a, buffer(b); kwargs...)
Base.isapprox(lhs::DitStr, rhs::DitStr; kwargs...) = false
Base.isapprox(a::T, b::T; kwargs...) where {T<:DitStr} =
    Base.isapprox(buffer(a), buffer(b); kwargs...)

# Note: it is a dit confusing, with x::DitStr == y::Integer,
# they behave different when used for indexing.
Base.to_index(x::DitStr) = error(
    "please do not use dit string for indexing, you may want to use `buffer(x)+1` for indexing to avoid ambiguity.",
)
Base.to_index(x::UnitRange{<:DitStr}) = error(
    "please do not use dit string for indexing, you may want to use `buffer(x)+1` for indexing to avoid ambiguity.",
)

# NOTE: maybe this is wrong?
Base.checkindex(::Type{Bool}, inds::AbstractUnitRange, i::DitStr) =
    checkindex(Bool, inds, Base.to_index(i))
Base.checkindex(::Type{Bool}, inds::Base.IdentityUnitRange, i::DitStr) =
    checkindex(Bool, inds, Base.to_index(i))
Base.length(::DitStr{D,N,T}) where {D,N,T} = N
Base.lastindex(dits::DitStr) = length(dits)

Base.typemax(::Type{DitStr{D,N,T}}) where {D,N,T} = DitStr{D,N,T}(_lshift(Val{D}(), one(T), N) - 1)
Base.typemax(::DitStr{D,N,T}) where {D,N,T} = DitStr{D,N,T}(_lshift(Val{D}(), one(T), N) - 1)
Base.typemin(::Type{DitStr{D,N,T}}) where {D,N,T} = DitStr{D,N,T}(0)
Base.typemin(::DitStr{D,N,T}) where {D,N,T} = DitStr{D,N,T}(0)

"""
    readat(x, loc...) -> Integer

Read the dit config at given location.
"""
@inline @generated function readat(x::DitStr{D,N,T}, locs::Integer...) where {D,N,T}
    length(locs) == 0 && return :(zero($T))
    Expr(:call, :+, [:($_lshift($(Val(D)), mod($_rshift($(Val{D}()), buffer(x), locs[$i] - 1), $D), $(i - 1))) for i = 1:length(locs)]...)
end

Base.@propagate_inbounds function Base.getindex(dit::DitStr{D,N}, index::Integer) where {D,N}
    @boundscheck 1 <= index <= N || throw(BoundsError(dit, index))
    return readat(dit, index)
end

Base.@propagate_inbounds function Base.getindex(dit::DitStr{D,N,T}, itr::AbstractVector) where {D,N,T}
    @boundscheck all(x -> 1 <= x <= N, itr) || throw(BoundsError(dit, itr))
    return map(x -> readat(dit, x), itr)
end


"""
    SubDitStr{D,N,T<:Integer} <: Integer

The struct as a `SubString`-like object for `DitStr`(`SubString` is an official implementation of sliced strings, see [String](https://docs.julialang.org/en/v1/base/strings/#Base.SubString) for reference). This slicing returns a view into the parent `DitStr` instead of making a copy (similar to the `@views` macro for strings).

`SubDitStr` can be used to describe the qubit configuration within the subspace of the entire Hilbert space.It provides similar `getindex`, `length` functions as `DitStr`. 

    SubDitStr(dit::DitStr{D,N,T}, i::Int, j::Int)
    SubDitStr(dit::DitStr{D,N,T}, r::AbstractUnitRange{<:Integer})

Or by `@views` macro for `DitStr` (this macro makes your life easier by supporting `begin` and `end` syntax):

    @views dit[i:j]

Returns a `SubDitStr`.

### Examples

```jldoctest
julia> x = DitStr{3, 5}(71)
02122 ₍₃₎

julia> sx =  SubDitStr(x, 2, 4) 
SubDitStr{3, 5, Int64}(02122 ₍₃₎, 1, 3)

julia> @views x[2:end] 
SubDitStr{3, 5, Int64}(02122 ₍₃₎, 1, 4)

julia> sx == dit"212;3"
true
```
"""
struct SubDitStr{D,N,T<:Integer} <: Integer
    dit::DitStr{D,N,T}
    offset::Int
    ncodeunits::Int

    function SubDitStr(dit::DitStr{D,N,T}, i::Int, j::Int) where {D,N,T}
        i ≤ j || return new{D,N,T}(dit, 0, 0)
        @boundscheck begin
            1 ≤ i ≤ length(dit) || throw(BoundsError(dit, i))
            1 ≤ j ≤ length(dit) || throw(BoundsError(dit, i))
        end
        return new{D,N,T}(dit, i - 1, j - i + 1)
    end
end

Base.@propagate_inbounds Base.view(dit::DitStr{D,N,T}, i::Integer, j::Integer) where {D,N,T} = SubDitStr(dit, i, j)
Base.@propagate_inbounds Base.view(dit::DitStr{D,N,T}, r::AbstractUnitRange{<:Integer}) where {D,N,T} = SubDitStr(dit, first(r), last(r))
Base.@propagate_inbounds Base.maybeview(dit::DitStr{D,N,T}, r::AbstractUnitRange{<:Integer}) where {D,N,T} = view(dit,r) 

"""
    DitStr(dit::SubDitStr{D,N,T}) -> DitStr{D,N,T}
Raise type `SubDitStr` to `DitStr`.
```jldoctest
julia> x = DitStr{3, 5}(71)
02122 ₍₃₎

julia> sx =  SubDitStr(x, 2, 4)
SubDitStr{3, 5, Int64}(02122 ₍₃₎, 1, 3)

julia> DitStr(sx)
212 ₍₃₎
```
"""
function DitStr(dit::SubDitStr{D,N,T}) where {D,N,T}
    val = zero(T)
    D_power_k = one(T)
    len = ncodeunits(dit)
    for k in 1:len
        val = accum(Val{D}(), val, readat(dit.dit, dit.offset + k), D_power_k)
        D_power_k = _lshift(Val{D}(), D_power_k, 1)
    end
    return DitStr{D,len,T}(val)
end

ncodeunits(dit::SubDitStr{D,N,T}) where {D,N,T} = dit.ncodeunits

## bounds checking ##
Base.checkbounds(::Type{Bool}, dit::SubDitStr{D,N,T}, i::Integer) where {D,N,T} =
    1 ≤ i ≤ ncodeunits(dit)
Base.checkbounds(::Type{Bool}, dit::SubDitStr{D,N,T}, r::AbstractRange{<:Integer}) where {D,N,T} =
    isempty(r) || (1 ≤ minimum(r) && maximum(r) ≤ ncodeunits(dit))
Base.checkbounds(::Type{Bool}, dit::SubDitStr{D,N,T}, I::AbstractArray{<:Integer}) where {D,N,T} =
    all(i -> checkbounds(Bool, dit, i), I)
Base.checkbounds(dit::SubDitStr{D,N,T}, I::Union{Integer,AbstractArray}) where {D,N,T} = checkbounds(Bool, dit, I) ? nothing : throw(BoundsError(dit, I))

Base.@propagate_inbounds SubDitStr(dit::DitStr{D,N,T}, i::Integer, j::Integer) where {D,N,T} = SubDitStr{D,N,T}(dit, i, j)
Base.@propagate_inbounds SubDitStr(dit::DitStr{D,N,T}, r::AbstractUnitRange{<:Integer}) where {D,N,T} = SubDitStr{D,N,T}(dit, first(r), last(r))

Base.@propagate_inbounds function SubDitStr(dit::SubDitStr{D,N,T}, i::Int, j::Int) where {D,N,T}
    @boundscheck i ≤ j && checkbounds(dit, i:j)
    SubString(dit.dit, dit.offset + i, dit.offset + j)
end

Base.length(dit::SubDitStr{D,N,T}) where {D,N,T} = ncodeunits(dit)

"""
    ==(lhs::SubDitStr{D,N,T}, rhs::DitStr{D,N,T}) -> Bool
    ==(lhs::DitStr{D,N,T}, rhs::SubDitStr{D,N,T}) -> Bool
    ==(lhs::SubDitStr{D,N,T}, rhs::SubDitStr{D,N,T}) -> Bool
Compare the equality between `SubDitStr` and `DitStr`. 
"""
function Base.:(==)(lhs::SubDitStr{D,N1}, rhs::DitStr{D,N2}) where {D,N1,N2}
    length(lhs) == length(rhs) && @inbounds all(i -> lhs[i] == rhs[i], 1:length(lhs))
end

function Base.:(==)(lhs::SubDitStr{D,N1}, rhs::SubDitStr{D,N2}) where {D,N1,N2}
    length(lhs) == length(rhs) && @inbounds all(i -> lhs[i] == rhs[i], 1:length(lhs))
end

function Base.:(==)(lhs::DitStr{D,N1}, rhs::SubDitStr{D,N2}) where {D,N1,N2}
    length(lhs) == length(rhs) && @inbounds all(i -> lhs[i] == rhs[i], 1:length(lhs))
end

function Base.getindex(dit::SubDitStr{D,N,T}, i::Integer) where {D,N,T}
    @boundscheck checkbounds(dit, i)
    @inbounds return getindex(dit.dit, dit.offset + i)
end


# TODO: support AbstractArray, should return its corresponding shape

Base.@propagate_inbounds function Base.getindex(
    dit::DitStr{D,N,T},
    mask::AbstractVector{Bool},
) where {D,N,T}
    @boundscheck N == length(mask) || error("length of dits and mask does not match.")

    out = T[]
    for k in eachindex(mask)
        if mask[k]
            push!(out, dit[k])
        end
    end
    return out
end

Base.eltype(::DitStr{D,N,T}) where {D,N,T} = T

function Base.iterate(dit::DitStr, state::Integer=1)
    if state > length(dit)
        return nothing
    else
        return dit[state], state + 1
    end
end
Base.IteratorSize(::DitStr) = Base.HasLength()

"""
    basis(ditstr) -> UnitRange{DitStr{D,N,T}}
    basis(DitStr{D,N,T}) -> UnitRange{DitStr{D,N,T}}

Returns the `UnitRange` for basis in Hilbert Space of qudits.
"""
basis(b::DitStr) = typemin(b):typemax(b)
basis(::Type{DitStr{D,N,T}}) where {D,N,T} = UnitRange(typemin(DitStr{D,N,T}), typemax(DitStr{D,N,T}))

function Base.rand(::Type{T}) where {D,N,Ti,T<:DitStr{D,N,Ti}}
    return T(rand(typemin(T).buf:typemax(T).buf))
end

######################### Operations #####################
_lshift(::Val{D}, x::Integer, i::Integer) where {D} = x * (D^i)
_rshift(::Val{D}, x::Integer, i::Integer) where {D} = x ÷ (D^i)
_lshift(::Val{2}, x::Integer, i::Integer) = x << i
_rshift(::Val{2}, x::Integer, i::Integer) = x >> i

# expand iterator to tuple
sum_length(a::DitStr, dits::DitStr...) = length(a) + sum_length(dits...)
sum_length(a::DitStr) = length(a)

function Base.join(dit::DitStr{D,N,T}, dits::DitStr{D}...) where {D,N,T<:Integer}
    total_dits = sum_length(dit, dits...)
    val, len = zero(T), 0

    for k in length(dits):-1:1
        val += _lshift(Val(D), buffer(dits[k]), len)
        len += length(dits[k])
    end
    val += _lshift(Val(D), buffer(dit), len)
    len += length(dit)
    return DitStr{D,total_dits,T}(val)
end
Base.repeat(s::DitStr, n::Integer) = join([s for i in 1:n]...)

"""
    onehot([T=Float64], dit_str[; nbatch])

Create an onehot vector in type `Vector{T}` or a batch of onehot vector in type `Matrix{T}`, where index `x + 1` is one.
One can specify the value of the nonzero entry by inputing a pair.
"""
onehot(::Type{T}, n::DitStr{D,N,T1}; nbatch=nothing) where {D,T,N,T1} = _onehot(T, D^N, buffer(n) + 1; nbatch)
onehot(n::DitStr; nbatch=nothing) = onehot(ComplexF64, n; nbatch)

readbit(x::DitStr{D,N,LongLongUInt{C}}, loc::Int) where {D,N,C} = readbit(x.buf, loc)

########## @dit_str macro ##############
"""
    @dit_str -> DitStr64

Construct a dit string. such as `dit"0201;3"`. The dit strings also supports string `join`. Just use
it like normal strings.

## Example

```jldoctest
julia> dit"10201;3"
10201 ₍₃₎

julia> dit"100_121_121;3"
100121121 ₍₃₎

julia> join(dit"1021;3", dit"11;3", dit"1210;3")
1021111210 ₍₃₎

julia> onehot(dit"1021;3")
81-element Vector{ComplexF64}:
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
     ⋮
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im

```
"""
macro dit_str(str)
    return parse_dit(Int64, str)
end

"""
    @ldit_str -> LongDitStr

Long dit string version of `@dit_str` macro.
"""
macro ldit_str(str)
    return parse_dit(BigInt, str)
end

function parse_dit(::Type{T}, str::String) where {T<:Integer}
    res = match(r"(.*);(\d+)", str)
    if res === nothing
        error("Input string literal format error, should be e.g. `dit\"01121;3\"`")
    end
    return _parse_dit(Val(parse(Int, res[2])), T, res[1])
end

function _parse_dit(::Val{D}, ::Type{T}, str::AbstractString) where {D,T<:Integer}
    TT = T <: LongLongUInt ? longinttype(count(isdigit, str), D) : T
    _parse_dit_safe(Val(D), TT, str)
end

function _parse_dit_safe(::Val{D}, ::Type{T}, str::AbstractString) where {D,T<:Integer}
    val = zero(T)
    k = 0
    maxk = max_num_elements(T, D)
    for each in reverse(str)
        k >= maxk - 1 && error("string length is larger than $(maxk), use @ldit_str instead")
        v = each - '0'
        if 0 <= v < D
            val += _lshift(Val(D), T(v), k)
            k += 1
        elseif each == '_'
            continue
        else
            error("expect char in range 0-$(D-1), got $each at $(k+1)-th dit")
        end
    end
    return DitStr{D,k,T}(val)
end

max_num_elements(::Type{T}, D::Int) where {T<:Integer} = floor(Int, log(typemax(T)) / log(D))
max_num_elements(::Type{BigInt}, D::Int) = typemax(Int)
max_num_elements(::Type{LongLongUInt{C}}, D::Int) where {C} = max_num_elements(UInt, D) * C

using StaticArrays
export IterControl, itercontrol, controldo, group_shift!

# NOTE: use SortedVector in Blocks would help benchmarks

"""
    IterControl{S}
    IterControl(n::Int, base::Int, masks, factors) -> IterControl

Iterator to iterate through controlled subspace. See also [`itercontrol`](@ref).
 `S` is the number of chunks,
 `n` is the size of Hilbert space,
 `base` is the base of counter,
 `masks` and `factors` are helpers for enumerating over the target Hilbert Space.
"""
struct IterControl{S}
    n::Int
    base::Int
    masks::NTuple{S,Int}
    factors::NTuple{S,Int}

    function IterControl(n::Int, base::Int, masks::NTuple{S,Int}, factors::NTuple{S,Int}) where {S}
        new{S}(n, base, masks, factors)
    end
end

# NOTE: positions should be vector (MVector is the best), since it need to be sorted
#       do not use Tuple, or other immutables, it increases the sorting time.
"""
    itercontrol([T=Int], nbits, positions, bit_configs)

Returns an iterator which iterate through controlled subspace of bits.

# Example

To iterate through all the bits satisfy `0xx10x1` where `x` means an arbitrary bit.

```jldoctest
julia> for each in itercontrol(7, [1, 3, 4, 7], (1, 0, 1, 0))
           println(string(each, base=2, pad=7))
       end
0001001
0001011
0011001
0011011
0101001
0101011
0111001
0111011

```
"""
function itercontrol(nbits::Int, positions::AbstractVector, bit_configs)
    @assert all(x->iszero(x) || isone(x), bit_configs) "Bit configurations should be 0 or 1"
    base = bmask(Int, positions[i] for (i, u) in enumerate(bit_configs) if u != 0)
    masks, factors = group_shift!(nbits, positions)
    S = length(masks)
    return IterControl(1 << (nbits - length(positions)), base, Tuple(masks), Tuple(factors))
end

"""
    controldo(f, itr::IterControl)

Execute `f` while iterating `itr`.

!!! note

    this is faster but equivalent than using `itr` as an iterator.
    See also [`itercontrol`](@ref).
"""
function controldo(f::Base.Callable, ic::IterControl{S}) where {S}
    for i in 0:ic.n-1
        out = 0
        for s in 1:S
            @inbounds out += (i & ic.masks[s]) * ic.factors[s]
        end
        f(out + ic.base)
    end
    return nothing
end

Base.length(it::IterControl) = it.n
Base.eltype(it::IterControl) = Int

function Base.getindex(it::IterControl{S}, k::Int) where {S}
    out = 0
    k -= 1
    for s in 1:S
        @inbounds out += (k & it.masks[s]) * it.factors[s]
    end
    return out + it.base
end
Base.lastindex(it::IterControl) = it.n

function Base.iterate(it::IterControl, state = 1)
    if state > length(it)
        return nothing
    else
        return it[state], state + 1
    end
end

"""
    group_shift!(nbits, positions)

Shift bits on `positions` together.
"""
function group_shift!(nbits::Int, positions::AbstractVector{Int})
    sort!(positions)
    masks = Int[]
    factors = Int[]
    k_prv = 0
    i = 0
    for k in positions
        @assert k > k_prv "Conflict at location: $k"
        if k != k_prv + 1
            push!(factors, 1<<(k_prv-i))
            gap = k - k_prv-1
            push!(masks, bmask(i+1:i+gap))
            i += gap
        end
        k_prv = k
    end
    # the last block
    if i != nbits
        push!(factors, 1<<(k_prv-i))
        push!(masks, bmask(i+1:nbits))
    end
    return masks, factors
end

"""
    bitarray(v::Vector, [nbits::Int]) -> BitArray
    bitarray(v::Int, nbits::Int) -> BitArray
    bitarray(nbits::Int) -> Function

Construct BitArray from an integer vector, if nbits not supplied, it is 64.
If an integer is supplied, it returns a function mapping a Vector/Int to bitarray.
"""
function bitarray(v::Vector{T}, nbits::Int)::BitArray{2} where {T<:Number}
    ba = BitArray(undef, 0, 0)
    ba.len = 64 * length(v)
    ba.chunks = UInt64.(v)
    ba.dims = (64, length(v))
    view(ba, 1:nbits, :)
end

function bitarray(v::Vector{T})::BitArray{2} where {T<:Union{UInt64,Int64}}
    ba = BitArray(undef, 0, 0)
    ba.len = 64 * length(v)
    ba.chunks = reinterpret(UInt64, v)
    ba.dims = (64, length(v))
    ba
end

bitarray(v::Number, nbits::Int)::BitArray{1} = vec(bitarray([v], nbits))
bitarray(nbits::Int) = x -> bitarray(x, nbits)

basis(state::AbstractArray) = 0:size(state, 1)-1

"""
    packbits(arr::AbstractArray) -> AbstractArray

pack bits to integers, usually take a BitArray as input.
"""
packbits(arr::AbstractVector) = _packbits(arr)[]
packbits(arr::AbstractArray) = _packbits(arr)
_packbits(arr) =
    selectdim(sum(mapslices(x -> x .* (1 .<< (0:size(arr, 1)-1)), arr, dims = 1), dims = 1), 1, 1)

"""
    indicator(::Type{T}, k) -> T

Return an integer with `k`-th bit set to 1.
"""
indicator(::Type{T}, k::Int) where T<:Integer = one(T) << (k-1)

"""
    btruncate(b, n)

Truncate bits `b` to given length `n`.
"""
btruncate(b::T, n) where T<:Integer = b & (one(T) << n - 1)

"""
    bfloat(b::Integer; nbits::Int=bit_length(b)) -> Float64

float view, with current bit numbering.
See also [`bfloat_r`](@ref).

Ref: [wiki: bit numbering](https://en.wikipedia.org/wiki/Bit_numbering)
"""
bfloat(b::Integer; nbits::Int = bit_length(b)) = breflect(b; nbits = nbits) / (1 << nbits)

"""
    bfloat_r(b::Integer; nbits::Int=bit_length(b)) -> Float64

float view, with reversed bit numbering. See also [`bfloat`](@ref).
"""
bfloat_r(b::Integer; nbits::Int) = b / (1 << nbits)

"""
    bint(b; nbits=nothing) -> Int

integer view, with LSB 0 bit numbering.
See also [wiki: bit numbering](https://en.wikipedia.org/wiki/Bit_numbering)
"""
bint(b::Integer; nbits = nothing) = b
bint(x::Float64; nbits::Int) = breflect(bint_r(x, nbits = nbits); nbits = nbits)

"""
    bint_r(b; nbits::Int) -> Integer

integer read in inverse order.
"""
bint_r(b::Integer; nbits::Int) = breflect(b; nbits = nbits)
bint_r(x::Float64; nbits::Int) = Int(round(x * (1 << nbits)))


"""
    bmask(::Type{T}) where T <: Integer -> zero(T)
    bmask([T::Type], positions::Int...) -> T
    bmask([T::Type], range::UnitRange{Int}) -> T

Return an integer mask of type `T` where `1` is the position masked according to
`positions` or `range`. Directly use `T` will return an empty mask `0`.
"""
function bmask end

bmask(args...) = bmask(Int, args...)
bmask(::Type{T}) where {T<:Integer} = zero(T)
bmask(::Type{T}, positions::Int...) where {T<:Integer} = bmask(T, positions)
bmask(::Type{T}, itr) where {T<:Integer} =
    isempty(itr) ? 0 : reduce(+, indicator(T, b) for b in itr)

@inline function bmask(::Type{T}, range::UnitRange{Int})::T where {T<:Integer}
    ((one(T) << (range.stop - range.start + 1)) - one(T)) << (range.start - 1)
end

# NOTE: we have to return a vector here since this is calculated in runtime

"""
    baddrs(b::Integer) -> Vector

get the locations of nonzeros bits, i.e. the inverse operation of bmask.
"""
function baddrs(b::Integer)
    locs = Vector{Int}(undef, count_ones(b))
    k = 1
    for i in 1:bit_length(b)
        if readbit(b, i) == 1
            locs[k] = i
            k += 1
        end
    end
    return locs
end

"""
    readbit(x, loc...)

Read the bit config at given location.
"""
readbit(x::T, loc::Int) where {T<:Integer} = (x >> (loc - 1)) & one(T)

@inline @generated function readbit(x::T, bits::Int...) where {T<:Integer}
    Expr(:call, :+, [:(readbit(x, bits[$i]) << ($i - 1)) for i=1:length(bits)]...)
end

"""
    anyone(index::Integer, mask::Integer) -> Bool

Return `true` if any masked position of index is 1.

# Example

`true` if any masked positions is 1.

```jldoctest
julia> anyone(0b1011, 0b1001)
true

julia> anyone(0b1011, 0b1100)
true

julia> anyone(0b1011, 0b0100)
false
```
"""
anyone(index::T, mask::T) where {T<:Integer} = (index & mask) != zero(T)

"""
    allone(index::Integer, mask::Integer) -> Bool

Return `true` if all masked position of index is 1.

# Example

`true` if all masked positions are 1.

```jldoctest
julia> allone(0b1011, 0b1011)
true

julia> allone(0b1011, 0b1001)
true

julia> allone(0b1011, 0b0100)
false
```
"""
allone(index::T, mask::T) where {T<:Integer} = (index & mask) == mask

"""
    ismatch(index::Integer, mask::Integer, target::Integer) -> Bool

Return `true` if bits at positions masked by `mask` equal to `1` are equal to `target`.

## Example

```julia
julia> n = 0b11001; mask = 0b10100; target = 0b10000;

julia> ismatch(n, mask, target)
true
```
"""
ismatch(index::T, mask::T, target::T) where {T<:Integer} = (index & mask) == target

"""
    setbit(index::Integer, mask::Integer) -> Integer

set the bit at masked position to 1.

# Example

```jldoctest
julia> setbit(0b1011, 0b1100) |> BitStr{4}
1111 ₍₂₎

julia> setbit(0b1011, 0b0100) |> BitStr{4}
1111 ₍₂₎

julia> setbit(0b1011, 0b0000) |> BitStr{4}
1011 ₍₂₎
```
"""
setbit(index::T, mask::T) where {T<:Integer} = index | mask

"""
    flip(index::Integer, mask::Integer) -> Integer

Return an Integer with bits at masked position flipped.

# Example

```jldoctest
julia> flip(0b1011, 0b1011) |> BitStr{4}
0000 ₍₂₎
```
"""
flip(index::T, mask::T) where {T<:Integer} = index ⊻ mask

"""
    neg(index::Integer, nbits::Int) -> Integer

Return an integer with all bits flipped (with total number of bit `nbits`).

# Example

```jldoctest
julia> neg(0b1111, 4) |> BitStr{4}
0000 ₍₂₎

julia> neg(0b0111, 4) |> BitStr{4}
1000 ₍₂₎
```
"""
neg(index::T, nbits::Int) where {T<:Integer} = bmask(T, 1:nbits) ⊻ index

"""
    swapbits(n::Integer, mask_ij::Integer) -> Integer
    swapbits(n::Integer, i::Int, j::Int) -> Integer

Return an integer with bits at `i` and `j` flipped.

# Example

```jldoctest
julia> swapbits(0b1011, 0b1100) == 0b0111
true
```

!!! tip

    locations `i` and `j` specified by mask could be faster when [`bmask`](@ref)
    is not straight forward but known by constant.

!!! warning

    `mask_ij` should only contain two `1`, `swapbits` will not check it, use at
    your own risk.
"""
swapbits(b::T, i::Int, j::Int) where {T<:Integer} = swapbits(b, bmask(T, i, j))

@inline function swapbits(b::T, mask::T) where {T<:Integer}
    bm = b & mask
    if bm != 0 && bm != mask
        b ⊻= mask
    end
    return b
end

"""
    breflect(b::Integer[, masks::Vector{Integer}]; nbits) -> Integer

Return left-right reflected integer.

# Example

Reflect the order of bits.

```jldoctest
julia> breflect(0b1011; nbits=4) == 0b1101
true
```
"""
function breflect end

@inline function breflect(b::Integer; nbits::Int)
    @simd for i in 1:nbits÷2
        b = swapbits(b, i, nbits - i + 1)
    end
    return b
end

@inline function breflect(b::T, masks::AbstractVector{T}; nbits::Int)::T where {T<:Integer}
    @simd for m in masks
        b = swapbits(b, m)
    end
    return b
end

# TODO: use a more general trait if possible
const IntIterator{T} = Union{NTuple{<:Any,T},Vector{T},T,UnitRange{T}} where {T<:Integer}

"""
    controller([T=Int, ]cbits, cvals) -> Function

Return a function that checks whether a basis at `cbits` takes specific value `cvals`.
"""
function controller(cbits::IntIterator, cvals::IntIterator)
    controller(Int, cbits, cvals)
end
function controller(::Type{T}, cbits::IntIterator, cvals::IntIterator) where T
    do_mask = bmask(T, cbits...)
    target =
        length(cvals) == 0 ? zero(T) :
        mapreduce(xy -> (xy[2] == 1 ? indicator(T, xy[1]) : zero(T)), |, zip(cbits, cvals))
    return b -> ismatch(b, do_mask, target)
end

"""
    LongLongUInt{C} <: Integer

A `LongLongUInt{C}` is an integer with `C` `UInt` numbers to store the value.
"""
struct LongLongUInt{C} <: Integer
    content::NTuple{C, UInt}
    function LongLongUInt{C}(content::NTuple{C, UInt}) where {C}
        new{C}(content)
    end
    function LongLongUInt{C}(content::NTuple{C}) where {C}
        new{C}(UInt.(content))
    end
    function LongLongUInt(content::NTuple{C}) where {C}
        LongLongUInt{C}(content)
    end
end
bsizeof(::LongLongUInt{C}) where C = bsizeof(UInt64) * C
nint(::LongLongUInt{C}) where {C} = C
Base.Int(x::LongLongUInt{1}) = Int(x.content[1])
Base.UInt(x::LongLongUInt{1}) = x.content[1]
Base.zero(::Type{LongLongUInt{C}}) where {C} = LongLongUInt{C}(ntuple(_->UInt(0), Val{C}()))
Base.zero(::LongLongUInt{C}) where {C} = zero(LongLongUInt{C})
# convert from integers
LongLongUInt{C}(x::T) where {C, T<:Integer} = LongLongUInt{C}(ntuple(i->i==C ? UInt(x) : zero(UInt), Val{C}()))
Base.promote_rule(::Type{LongLongUInt{C}}, ::Type{Int}) where {C} = LongLongUInt{C}
Base.promote_rule(::Type{LongLongUInt{C}}, ::Type{UInt}) where {C} = LongLongUInt{C}
function Base.mod(x::LongLongUInt{C}, D::Int) where {C}
    D == 2 ? mod(x.content[end], 2) : error("mod only supports 2")
end

function Base.:(>>)(x::LongLongUInt{1}, y::Int)
    return LongLongUInt{1}(x.content[1] >> y)
end
function Base.:(<<)(x::LongLongUInt{1}, y::Int)
    return LongLongUInt{1}(x.content[1] << y)
end

function readbit(x::LongLongUInt{1}, loc::Int)
    return readbit(x.content[1], loc)
end
function indicator(::Type{LongLongUInt{1}}, i::Int)
    return LongLongUInt{1}(indicator(UInt, i))
end

function Base.:(<)(val1::LongLongUInt{1}, val2::LongLongUInt{1})
    return val1.content[1] < val2.content[1]
end

function Base.:(<)(val1::LongLongUInt{C}, val2::LongLongUInt{C}) where{C}
    for i in 1:C
        if val1.content[i] < val2.content[i]
            return true
        elseif val1.content[i] > val2.content[i]
            return false
        end
    end
    return false
end

function Base.:(>>)(x::LongLongUInt{C}, y::Int) where {C}
    y < 0 && return x << -y
    nshift = y ÷ bsizeof(UInt)
    nshift_inner = y % bsizeof(UInt)
    LongLongUInt(ntuple(Val{C}()) do k
            right = k<=nshift ? zero(UInt) : x.content[k-nshift]
            left = k<=(nshift+1) ? zero(UInt) : x.content[k-nshift-1]
            (right >> nshift_inner) | (left << (bsizeof(UInt) - nshift_inner))
        end
    )
end
function Base.:(<<)(x::LongLongUInt{C}, y::Int) where C
    y < 0 && return x >> -y
    nshift = y ÷ bsizeof(UInt)
    nshift_inner = y % bsizeof(UInt)
    LongLongUInt(ntuple(Val{C}()) do k
            left = k>C-nshift ? zero(UInt) : x.content[k+nshift]
            right = k>C-nshift-1 ? zero(UInt) : x.content[k+nshift+1]
            (left << nshift_inner) | (right >> (bsizeof(UInt) - nshift_inner))
        end
    )
end
function readbit(x::LongLongUInt{C}, loc::Int) where {C}
    k = (loc-1) ÷ bsizeof(UInt)
    return readbit(x.content[C-k], loc - k*bsizeof(UInt))
end
function indicator(::Type{LongLongUInt{C}}, i::Int) where C
    k = (i-1) ÷ bsizeof(UInt)
    LongLongUInt{C}(ntuple(j->j==C-k ? indicator(UInt, i-k*bsizeof(UInt)) : zero(UInt), Val{C}()))
end
for OP in [:&, :|, :xor]
    @eval Base.$OP(x::LongLongUInt{C}, y::LongLongUInt{C}) where {C} = LongLongUInt{C}($OP.(x.content, y.content))
end
Base.:(~)(x::LongLongUInt{C}) where {C} = LongLongUInt{C}((~).(x.content))
function Base.:(+)(x::LongLongUInt{C}, y::LongLongUInt{C}) where {C}
    return LongLongUInt(_sadd(x.content, y.content, false))
end
function _sadd(x::NTuple{1,UInt}, y::NTuple{1,UInt}, c::Bool)
    return (x[1] + y[1] + c,)
end
function _sadd(x::NTuple{C,UInt}, y::NTuple{C,UInt}, c::Bool) where {C}
    v1, c1 = Base.add_with_overflow(x[C], y[C])
    if c
        v2, c2 = Base.add_with_overflow(v1, c)
        c = c1 || c2
        return (_sadd(x[1:C-1], y[1:C-1], c)..., v2)
    else
        return (_sadd(x[1:C-1], y[1:C-1], c1)..., v1)
    end
end
function Base.:(-)(x::LongLongUInt{C}, y::LongLongUInt{C}) where {C}
    return LongLongUInt(_ssub(x.content, y.content, false))
end
function _ssub(x::NTuple{1,UInt}, y::NTuple{1,UInt}, c::Bool)
    return (x[1] - y[1] - c,)
end
function _ssub(x::NTuple{C,UInt}, y::NTuple{C,UInt}, c::Bool) where {C}
    v1, c1 = Base.sub_with_overflow(x[C], y[C])
    if c
        v2, c2 = Base.sub_with_overflow(v1, one(UInt))
        c = c1 || c2
        return (_ssub(x[1:C-1], y[1:C-1], c)..., v2)
    else
        return (_ssub(x[1:C-1], y[1:C-1], c1)..., v1)
    end
end
Base.count_ones(x::LongLongUInt) = sum(count_ones, x.content)
Base.bitstring(x::LongLongUInt) = join(bitstring.(x.content), "")

function longinttype(n::Int, D::Int)
    N = ceil(Int, n * log2(D))
    C = (N-1) ÷ bsizeof(UInt) + 1
    return LongLongUInt{C}
end

Base.hash(x::LongLongUInt{1}) = hash(x.content[1])
Base.hash(x::LongLongUInt{C}) where{C} = hash(x.content)

######################## BitStr #########################
"""
    BitStr{N,T} <: Integer

The struct for bit string with fixed length `N` and storage type `T`.
It is an alias of `DitStr{2,N,T}`.

    BitStr{N,T}(integer)
    BitStr64{N}(integer)
    BitStr64(vector)
    LongBitStr{N}(integer)
    LongBitStr(vector)

Returns a `BitStr`.
When the input is an integer, the bits are read from right to left.
When the input is a vector, the bits are read from left to right.

## Examples

`BitStr` supports some basic arithmetic operations. It acts like an integer, but supports
some frequently used methods for binary basis.

```jldoctest
julia> bit"0101" * 2
1010 ₍₂₎

julia> join([bit"101" for i in 1:10])
"101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎101 ₍₂₎"

julia> repeat(bit"101", 2)
101101 ₍₂₎

julia> bit"1101"[2]
0
```
"""
const BitStr{N,T} = DitStr{2,N,T}
const BitStr64{N} = BitStr{N,Int64}
const LongBitStr{N} = BitStr{N,LongLongUInt{C}} where C
const BitStr{N}(x::T) where {N,T<:IntStorage} = DitStr{2,N}(x)
const BitStr(x::Union{Vector,Tuple}) = DitStr{2}(x)

# only for bitstr
for op in [:(>>), :(<<)]
    @eval Base.$op(a::BitStr{N,T}, b::Int) where {N,T} = BitStr{N,T}(Base.$op(buffer(a), b))
end

for op in [:count_ones, :count_zeros, :leading_ones, :leading_zeros, :trailing_zeros, :trailing_ones]
    @eval Base.$op(a::BitStr) = Base.$op(buffer(a))
end

########## @bit_str macro ##############
"""
    @bit_str -> BitStr64

Construct a bit string. such as `bit"0000"`. The bit strings also supports string `join`. Just use
it like normal strings.

## Example

```jldoctest
julia> bit"10001"
10001 ₍₂₎

julia> bit"100_111_101"
100111101 ₍₂₎

julia> join(bit"1001", bit"11", bit"1110")
1001111110 ₍₂₎

julia> onehot(bit"1001")
16-element Vector{ComplexF64}:
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 1.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im

```
"""
macro bit_str(str)
    return _parse_dit(Val(2), Int64, str)
end

"""
    @lbit_str -> LongBitStr

Long bit string version of `@bit_str` macro.
"""
macro lbit_str(str)
    return _parse_dit(Val(2), LongLongUInt, str)
end

"""
    breflect(bit_str[, masks])

Return left-right reflected bit string.
"""
breflect(b::BitStr{N}) where {N} = breflect(b; nbits = N)
breflect(b::BitStr{N,T}, masks::Vector{<:BitStr{N,T}}) where {N,T} =
    BitStr{N,T}(breflect(buffer(b), reinterpret(T, masks); nbits = N))

"""
    neg(b::BitStr) -> BitStr
"""
neg(b::BitStr{N}) where {N} = neg(b, N)

"""
    bfloat(b::BitStr) -> Float64
"""
bfloat(b::BitStr{N}) where {N} = bfloat(buffer(b); nbits = N)

"""
    bfloat_r(b::BitStr) -> Float64
"""
bfloat_r(b::BitStr{N}) where {N} = bfloat_r(buffer(b); nbits = N)

"""
    bint_r(b::BitStr) -> Integer
"""
bint_r(b::BitStr{N}) where {N} = buffer(breflect(b))

"""
    bint(b::BitStr) -> Integer
"""
bint(b::BitStr) = buffer(b)

using Test, BitBasis

ind = 12
inds = Int[12, 2]

@test readbit(12, 2) == 0
@test readbit.([12, 2], 2) == [0, 1]
@test readbit.(12, [3, 2]) == [1, 0]
@test readbit.(12, [3, 2], [2, 3]) == [1, 2]
@test bmask(baddrs(13)...) == 13

@test flip(12, bmask(1)) == 13
@test flip(12, bmask(1, 3)) == 9
@test flip.([12, 2], bmask(2)) == [14, 0]
@test flip.([12, 2], bmask(2, 1)) == [15, 1]

@test setbit.(inds, bmask(2, 1)) == [15, 3]

# bitarray version
# b - bitarray and take bit
ba1_f = bitarray(ind, 64)
ba2_f = bitarray(Int64.(inds))
ba3_f = bitarray(Int32.(inds), 32)
@test size(ba1_f) == (64,)
@test size(ba2_f) == (64, 2)
@test Int.(ba2_f[1:32, :]) == Int.(ba3_f)

ba1 = bitarray(ind, 4)
ba2 = bitarray(inds, 4)
@test size(ba1) == (4,)
@test size(ba2) == (4, 2)
@test ind |> bitarray(4) == ba1
@test inds |> bitarray(4) == ba2

@test ba1[2, 1] == readbit(ind, 2)
@test ba1[[3, 2], 1] == readbit.(ind, [3, 2])
@test ba2[2, :] == readbit.([ind, 2], 2)

msk = bmask(2, 5)
@test swapbits(7, msk) == 21
@test breflect(Int(0b0110001); nbits = 7) ==
      Int(0b1000110) ==
      breflect(Int(0b0110001), [bmask(1, 7), bmask(2, 6), bmask(3, 5)]; nbits = 7)

@test bitarray(2, 4) == [false, true, false, false]
@test packbits(BitArray([true, true, true])) == 7

@test packbits(bitarray(3, 10)) == 3
@test packbits(bitarray([5, 3, 7, 21], 10)) == [5, 3, 7, 21]

@testset "bint & bfloat" begin
    @test bint(5) == 5
    @test bint_r(3, nbits = 4) == 12
    @test bfloat(3) == 0.75
    @test bfloat_r(3; nbits = 4) == 0.75 / 4
    @test bint_r(0.75, nbits = 3) == 6
    @test bint(0.75, nbits = 3) == 3
end

@testset "random" begin
    @test rand(BitStr64{5}) isa BitStr64{5}
end

@testset "controller" begin
    c = controller(Int128, [2,3], [0, 1])
    @test c(Int128(3)) == false
    @test c(Int128(0b101)) == true
end

using Test, BitBasis

@test bsizeof(ind) == sizeof(Int) * 8
@test BitBasis._onehot(Float64, 4, 3) == [0, 0, 1, 0.0]
@test bdistance(1, 7) == 2
@test onehot(ComplexF64, bit"01"; nbatch=2) == transpose(ComplexF64[0 1 0 0; 0 1 0 0])
@test log2dim1(rand(4, 4)) == log2i(4)

@testset "log2i" begin
    for itype in [Int8, Int16, Int32, Int64, Int128, UInt8, UInt16, UInt32, UInt64, UInt128]
        @test log2i(itype(2^5)) == 5
        @test typeof(log2i(itype(2^5))) == Int
    end
end

@testset "bit length" begin
    @test bit_length(8) == 4
    @test bit_length(Int32(8)) == 4
end

@testset "indices with" begin
    # indices_with
    nbit = 5
    poss, vals = [4, 2, 3], [1, 0, 1]
    @test indices_with(nbit, poss, vals) == filter(x -> readbit.(x, poss) == vals, basis(BitStr64{nbit}))
end

```@meta
DocTestSetup = quote
    using BitBasis, Dates
end
```

# BitBasis

Manipulate binary (and nary) basis in an elegant efficient way in Julia.

```@eval
using Markdown, Dates
Markdown.parse("*Documentation built* **$(Dates.now())** *with Julia* **$(VERSION)**")
```

## Introduction

This package provides tools for manipulating binary basis in an elegant efficient way in Julia. Binary basis are used to represent states of spins, qubits, qudits, etc. It stores the basis as an integer with little-endian ordering, e.g `5` for `00101`, `6` for `00110`, etc.

## Contents
```@contents
Pages = [
    "tutorial.md",
    "man.md",
]
```

```@meta
CurrentModule = BitBasis
```

```@setup tutorial
using BitBasis
```

## Bit strings

This package provides a [string literal](https://docs.julialang.org/en/v1/manual/strings/#non-standard-string-literals) `@bit_str` to represent bit strings.
```@repl tutorial
b = bit"11100"
BitStr{5}(0b11100)  # convert from integer
bit_literal(0, 0, 1, 1, 1)  # from bit literals

[b...]  # convert to a vector of bits
b[2]  # indexing the 2nd bit
b.buf  # the storage type is `Int64` by default
typeof(b)
bit_length(b)  # the length of bit string
```
The type of `b` is `DitStr{2, 5, Int64}`, which means it is a bit string with 5 bits and the storage type is `Int64`. The `buf` field is the integer representation of the bit string.
Bit strings are represented as integers in the little-endian order, e.g. integer `28` represents the bit string `11100`.
```@raw html
<img src="assets/bitbasic.png" alt="11100" width="400"/>
```
The `bit_literal` function uses the array order to represent the bit string, which is different from the bit string literal, i.e. the leftmost bit is the least significant bit in the `bit_literal` function.

To represent bit strings with more than 64 bits, one can specify the storage type as `Int128` or `BigInt`.
```@repl tutorial
b = bit_literal(rand(BigInt[0, 1], 200)...)
typeof(b)
```

## Dit Strings
A nary basis is a generalization of a binary basis by changing the base from 2 to n.
. A dit string is a nary basis with a given base. The `@dit_str` string literal is used to represent dit strings.
For example, to represent a dit string with base 3, one can use the following code.
```@repl tutorial
d = dit"12210;3"
typeof(d)
```
The operations on dit strings are similar to those on bit strings.

## Concatenation and Repetition
To concatenate and repeat bit strings, one can use `join` and `repeat` functions.
```@repl tutorial
join([bit"101" for i in 1:10]...)  # concatenate bit strings
repeat(bit"101", 2)  # repeat bit string
```

## Readout
To readout bits, one can use [`readbit`](@ref) and [`baddrs`](@ref) functions.
```@raw html
<img src="assets/11100.png" alt="11100" width="400"/>
```

```@repl tutorial
readbit(bit"11100", 2, 3)  # read the 2nd and 3rd bits as `x₃x₂`
baddrs(bit"11100")  # locations of one bits
```

A bit string can be read out as numbers in the following ways:
* [`bint`](@ref), the integer itself
* [`bint_r`](@ref), the integer with bits small-big end reflected.
* [`bfloat`](@ref), the float point number ``0.σ₁σ₂ \cdots σ_n``.
* [`bfloat_r`](@ref), the float point number ``0.σ_n \cdots σ₂σ₁``.
These functions are useful in quantum computing algorithms such as phase estimation and HHL.

```@raw html
<img src = "assets/010101.png" alt="010101" width="400"/>
```


```@repl tutorial
bint(bit"010101")
bint_r(bit"010101")
bfloat(bit"010101")
bfloat_r(bit"010101")
```


## Modification
To flip all bits, one can use the [`neg`](@ref) function.
```@repl tutorial
neg(bit"1011")  # flip all bits
```

To truncate bits, one can use the [`btruncate`](@ref) function.
```@repl tutorial
btruncate(bit"1011", 2)  # only keep the first 2 qubits
```

To change the order of bits, one can use [`breflect`](@ref) function.
```@raw html
<img src="assets/breflect.png" alt="1011_1101" width="200"/>
```

```@repl tutorial
breflect(bit"1011")  # reflect little end and big end
```

## Masked Operations
One can use [`bmask`](@ref) to generate a mask for bit strings, and then use the mask to perform operations like [`allone`](@ref), [`anyone`](@ref), [`ismatch`](@ref), [`flip`](@ref), [`setbit`](@ref), [`swapbits`](@ref), etc.

```@repl tutorial
mask = bmask(BitStr{4, Int}, 1,3,4)  # mask bits 1, 3, 4
```
By coloring the masked positions in light blue, we have
```@raw html
<img src="assets/1011_1101.png" alt="1011_1101" width="400"/>
```

```@repl tutorial
allone(bit"1011", mask)  # true if all masked positions are 1
anyone(bit"1011", mask)  # true if any masked positions is 1
ismatch(bit"1011", mask, bit"1001")  # true if masked part matches `1001`
flip(bit"1011", mask)  # flip masked positions: 1, 3, 4
setbit(bit"1011", bit"1100") # set masked positions to 1
swapbits(bit"1011", bit"1100")  # swap masked positions
```

## Hamming Distance

One can calculate the Hamming distance between two bit strings by [`bdistance`](@ref) function.
```@repl tutorial
bdistance(bit"11100", bit"10101")  # Hamming distance
```

## Hilbert Space

The [`basis`](@ref) function is used to iterate over the basis of a given number of bits.

```@repl tutorial
itr = basis(BitStr{4, Int})
collect(itr)
```

Iterating over basis in a controlled way plays an important role in quantum simulation. The [`itercontrol`](@ref) function is used to iterate over basis in a controlled way.
For example, if we want to iterate over the basis of 7 qubits, and we only want to iterate over the basis with the 1st, 3rd, 4th, and 7th qubits being 1, 0, 1, and 0, respectively, we can use the following code.
```@repl tutorial
for each in itercontrol(7, [1, 3, 4, 7], (1, 0, 1, 0))
    println(string(each, base=2, pad=7))
end
```


```@repl tutorial
v = onehot(bit"11100")  # the one hot vector representation of given bits
reorder(v, (3,2,1,5,4)) ≈ onehot(bit"11001")  # change the order of bits
invorder(v) ≈ onehot(bit"00111")  # change the order of bits
```

## BitArray Utilities
Utilities are provided to cast between integers and the `BitArray` type in Julia standard library.
* `bitarray(integers, nbits)`, transform integers to `BitArray`.
* `packabits(bitstring)`, transform `BitArray` to integers.

```@repl tutorial
barr = bitarray(28, 5)
packbits(barr)
barr_mult = bitarray([4, 5, 6], 5)
packbits(barr_mult)
```
